首页 > 代码库 > hdu 5514 Frogs 容斥思想+gcd 银牌题
hdu 5514 Frogs 容斥思想+gcd 银牌题
Frogs
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 1509 Accepted Submission(s): 498
Problem Description
There are m stones lying on a circle, and n frogs are jumping over them.
The stones are numbered from 0 to m−1 and the frogs are numbered from 1 to n. The i-th frog can jump over exactly ai stones in a single step, which means from stone j mod m to stone (j+ai) mod m (since all stones lie on a circle).
All frogs start their jump at stone 0, then each of them can jump as many steps as he wants. A frog will occupy a stone when he reach it, and he will keep jumping to occupy as much stones as possible. A stone is still considered ``occupied" after a frog jumped away.
They would like to know which stones can be occupied by at least one of them. Since there may be too many stones, the frogs only want to know the sum of those stones‘ identifiers.
The stones are numbered from 0 to m−1 and the frogs are numbered from 1 to n. The i-th frog can jump over exactly ai stones in a single step, which means from stone j mod m to stone (j+ai) mod m (since all stones lie on a circle).
All frogs start their jump at stone 0, then each of them can jump as many steps as he wants. A frog will occupy a stone when he reach it, and he will keep jumping to occupy as much stones as possible. A stone is still considered ``occupied" after a frog jumped away.
They would like to know which stones can be occupied by at least one of them. Since there may be too many stones, the frogs only want to know the sum of those stones‘ identifiers.
Input
There are multiple test cases (no more than 20), and the first line contains an integer t,
meaning the total number of test cases.
For each test case, the first line contains two positive integer n and m - the number of frogs and stones respectively (1≤n≤104, 1≤m≤109).
The second line contains n integers a1,a2,?,an, where ai denotes step length of the i-th frog (1≤ai≤109).
meaning the total number of test cases.
For each test case, the first line contains two positive integer n and m - the number of frogs and stones respectively (1≤n≤104, 1≤m≤109).
The second line contains n integers a1,a2,?,an, where ai denotes step length of the i-th frog (1≤ai≤109).
Output
For each test case, you should print first the identifier of the test case and then the sum of all occupied stones‘ identifiers.
Sample Input
32 129 103 6022 33 669 9681 40 48 32 64 16 96 42 72
Sample Output
Case #1: 42Case #2: 1170Case #3: 1872
Source
2015ACM/ICPC亚洲区沈阳站-重现赛(感谢东北大学)
题意:有n只青蛙,m个石头(围成圆圈)。第i只青蛙每次只能条ai个石头,问最后所有青蛙跳过的石头的下标总和是多少?
#include <cstdio>#include <iostream>#include <algorithm>#include <cstring>#include <iostream>#include <cmath>#include <map>#include <bitset>#include <stack>#include <queue>#include <vector>#include <bitset>#include <set>#define MM(a,b) memset(a,b,sizeof(a));#define inf 0x3f3f3f3fusing namespace std;typedef long long ll;#define CT continue#define SC scanfconst int N=2*1e5+10;int factor[N],num[N],appear[N],step[N];ll add[N];int gcd(int a,int b){ if(b==0) return a; else return gcd(b,a%b);}int main(){ int cas,n,m,kk=0; SC("%d",&cas); while(cas--){ SC("%d%d",&n,&m); int cnt=0;MM(num,0);MM(appear,0); for(int i=1;i<=n;i++) SC("%d",&step[i]); for(int i=1;i*i<=m;i++) if(m%i==0){ factor[++cnt]=i; if(i*i!=m) factor[++cnt]=m/i; } sort(factor+1,factor+cnt+1); cnt--; for(int i=1;i<=cnt;i++){ ll k=(m-1)/factor[i]; add[i]=k*(k+1)/2*factor[i]; } for(int i=1;i<=n;i++){ int k=gcd(step[i],m); for(int j=1;j<=cnt;j++) if(factor[j]%k==0) appear[j]=1; } ll ans=0; for(int i=1;i<=cnt;i++) if(num[i]!=appear[i]){ ans+=add[i]*(appear[i]-num[i]); for(int j=i+1;j<=cnt;j++) if(factor[j]%factor[i]==0) num[j]+=(appear[i]-num[i]); } printf("Case #%d: %lld\n",++kk,ans); } return 0;}
分析:
1.一个数的因子个数大概是log级别;
2.ax+by=c有非负整数解的条件是c%gcd(a,b);取余
=>ax+by=k*gcd(a,b) =>ax%b=k*gcd(a,b)%b =>ai*x%m=k*gcd(ai,m)%m;
所以,青蛙能走到的格子数是k*gcd(ai,m),而gcd(ai,m)又必然是m的因数,所以可以先分解出m的因子
3.但是因为有些格子可能同时被多只青蛙走,因此需要容斥一下,设appear[i]为格子i应该走的次数(只有0,1)两个值,num[i]为格子i到当前为止实际走的次数,如果当前appear[i]>appear[i],就需要加,否则减去,然后将是当前因子factor[i]倍数的因子也同时跟新num值
hdu 5514 Frogs 容斥思想+gcd 银牌题
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。